diff --git a/src/regcomp.c b/src/regcomp.c
index 4d5b78fe..737c7d7b 100644
--- a/src/regcomp.c
+++ b/src/regcomp.c
@@ -656,8 +656,11 @@ static void
 mmcl_alt_merge(MinMaxCharLen* to, MinMaxCharLen* alt)
 {
   if (to->min > alt->min) {
-    to->min = alt->min;
-    if (alt->min_is_sure != 0)
+    to->min         = alt->min;
+    to->min_is_sure = alt->min_is_sure;
+  }
+  else if (to->min == alt->min) {
+    if (alt->min_is_sure != FALSE)
       to->min_is_sure = TRUE;
   }
 
